(* $Id: miniui.ml 953 2011-09-02 21:28:08Z gerd $
 * ----------------------------------------------------------------------
 * Copyright 2003 by Gerd Stolpmann. 
 * 
 * This file is part of godi-tools. 
 *
 * godi-tools is free software; you can redistribute it and/or modify it
 * under the conditions in the file LICENSE.
 *
 * godi-tools is distributed WITHOUT ANY WARRANTY, as detailed in the
 * file LICENSE.
 *)

type region = [ `Head | `Body ];;

type line_spec = [ `Replace of int | `Append ];;

type key_spec = [ `Keypress of char | `Number of int ];;


class type page =
object('self)
  method configure : ?head_region_height:int ->
                     ?auto_scroll:bool ->
                     unit ->
		       unit
  method width : unit -> int
  method height : ?region:region -> unit -> int
  method clear : unit -> unit
  method put_line : ?region:region ->
                    ?line:line_spec ->
                    ?lmargin:int ->
		    ?rmargin:int ->
		    string ->
		      unit
  method get_line : ?region:region -> int -> string
  method length : ?region:region -> unit -> int
  method add_body_button : line:int ->
                           ?left:int ->
                           ?width:int ->
			   ?callback:(unit -> unit) ->
                           key_spec ->
			     button_id
  method add_foot_button : ?text:string ->
                           ?underline:int ->
                           ?callback:(unit -> unit) ->
                           key_spec ->
			     button_id
  method remove_button : button_id -> unit
  method activate_text_entry : ?value:string ->
                               ?prompt:string ->
                               ?hidden:bool ->
                               ?callback_ok:(string -> unit) ->
			       ?callback_cancel:(unit -> unit) ->
			       unit ->
				 unit

  method set_busy : bool -> unit
  method busy : bool
  method set_scroll_position : float -> unit
  method scroll_position : float
  method update : ?force:bool -> unit -> unit
  method poll_event : unit -> unit
  method quit : unit -> unit
  method loop : unit -> unit
  method close : unit -> unit
  method new_page : unit -> page
end

and button_id = object end
;;
